﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls;

namespace Hierarchy_HidePlusSigns
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.radGridView1.ViewCellFormatting += new CellFormattingEventHandler(radGridView1_ViewCellFormatting);
        }

        void radGridView1_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.CellElement is GridGroupExpanderCellElement)
            {
                GridViewDataRowInfo row = e.CellElement.RowInfo as GridViewDataRowInfo;
                GridViewChildRowCollection chRows = row.ChildRows;
                if (chRows.Count == 0)
                {
                    e.CellElement.Visibility = ElementVisibility.Hidden;
                }
                else
                {
                    e.CellElement.Visibility = ElementVisibility.Visible;
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeGrid();
        }

        private void InitializeGrid()
        {
            DataTable table = new DataTable();
            table.Columns.Add("col1");
            table.Columns.Add("col2");
            table.Columns.Add("col3");
            table.Columns.Add("col4");
            for (int i = 0; i <= 1000; i++)
            {
                DataRow newRowItem = table.NewRow();
                newRowItem[0] = "Test1-" + i.ToString();
                newRowItem[1] = "Test2-" + i.ToString();
                newRowItem[2] = "Test3-" + i.ToString();
                newRowItem[3] = "Test4-" + i.ToString();
                table.Rows.Add(newRowItem);
            }
            this.radGridView1.MasterGridViewTemplate.ShowRowHeaderColumn = false;
            this.radGridView1.MasterGridViewTemplate.AllowAddNewRow = false;
            this.radGridView1.MasterGridViewTemplate.AllowColumnReorder = true;
            this.radGridView1.MasterGridViewTemplate.AllowAutoSizeColumns = false;
            this.radGridView1.MasterGridViewTemplate.AllowEditRow = true;
            this.radGridView1.MasterGridViewTemplate.EnableGrouping = true;
            this.radGridView1.MasterGridViewTemplate.AutoExpandGroups = true;
            this.radGridView1.MasterGridViewTemplate.AllowDragToGroup = true;
            this.radGridView1.UseScrollbarsInHierarchy = true;
            this.radGridView1.MultiSelect = true;
            this.radGridView1.EnableFiltering = true;
            this.radGridView1.ShowGroupPanel = true;
            this.radGridView1.DataSource = table.Copy();
            this.radGridView1.SelectionMode = GridViewSelectionMode.CellSelect;
            foreach (GridViewDataColumn col in this.radGridView1.Columns)
            {
                col.HeaderText = "HeaderText" + col.FieldName;
            }

            for (int i = 0; i < 1; i++)
            {
                GridViewTemplate childTmpt = new GridViewTemplate();
                childTmpt.DataSource = table.Copy();
                ((DataTable)childTmpt.DataSource).Rows.RemoveAt(0);
                ((DataTable)childTmpt.DataSource).Rows.RemoveAt(2);
                ((DataTable)childTmpt.DataSource).Rows.RemoveAt(4);
                childTmpt.Caption = "subtable" + i.ToString();
                GridViewRelation relation = new GridViewRelation(this.radGridView1.MasterTemplate);
                relation.ChildTemplate = childTmpt;
                this.radGridView1.MasterTemplate.Templates.Add(childTmpt);
                relation.ParentColumnNames.Add("col1");
                relation.ChildColumnNames.Add("col1");
                this.radGridView1.Relations.Add(relation);
            }

        }
    }
}
